#XenApp_Check_XA6
#CTXBLOG.fr

#Version : 1.1
#12/03/2012
#XenApp 6 compatible

#Version : 1.1.1
#03/08/2012
#Adding Farm Version in General Details

#Version : 1.5
#05/09/2012
#Adding "Cmdlet Execution Time" Section (by default this section are disabled, enabled this section by $Check_CmdletExecutionTime = "TRUE" in check function)
#Adding Uptime section (by default uptime = $sysuptime.days -ge 30), configure your uptime in Ctx_functionsXa6.ps1 (Function Uptime)
#Fix table bug
#coloring even lines by CSS3 (thx Vmdude) with "tr:nth-child(even)"

#Version : 1.6
#11/11/2012
#Adding "Server(s) type" section (physical, vm, xen or hyperV
#Fix bugs
#Add $Uptime = "30" (before this variable as set in Ctx_FunctionsXA6.ps1)
#Add  =>$Uptime day(s) : in uptime section
#Add Domain in General Dtail section
#Add Licence server TS/RDS in General Dtail section

#Version : 2.0
#11/12/2012
#Add "Split-Path -Parent $MyInvocation.MyCommand.Path" for Check directory script run
#Modify path function file ". "\\your share\XenApp_Check\Ctx_Functions.ps1" by ". $Path'Ctx_FunctionsXA6.ps1' "
#Add create backup folder if not exist on $Path
#Add check WMI error on Foreach ($Server in $Server) for reduce time execution XenApp_Check if WMI fail

#Version : 2.1
#11/02/2013
#Add Log folder (henceforth the html file is located in .\Log folder)
#Add display server in console (yellow start check, green end check)
#Adding "EdgeSight Version" Section

#Version : 2.2
#29/04/2013
#Add HotFix section

#Version : 2.3
#29/04/2013
#Add Load Server section

#Version : 2.5
#13/08/2014
#Optimize check WMI
#Add UPM section
#Add Section statut


#Version : 2.6
#03/12/2014
#Add check WorkerGroup in "Server in Application(s)" section


#Set-executionpolicy RemoteSigned
If ((Get-PSSnapin -Name "Citrix*" -ErrorAction SilentlyContinue | Measure-Object).count -eq 0) {asnp -Name "Citrix*"}

#XenApp_Check version
$Version = "2.6"

$host.ui.RawUI.WindowTitle = ("XenApp_Check v"+$Version)

clear
Write-host "XenApp_Check is started" -ForegroundColor  yellow `n

#Gets the farm information
#$scriptStartTime = get-date
$farm = Get-XAFarm
Write-host "GET-XAFarm done"
#$ExecutionTimeXaFarm= GetElapsedTime

#--------------------------------------#
#          Global Variables            #
#--------------------------------------#

#Time variable
$Date = Get-Date
#Domain
$Domain = $env:USERDNSDOMAIN
#Uptime
$Uptime = "30"
#XenApp_Check Disk
$DiskMin = "1.0"
#Load Evaluator
$LoadEval_Check = "LE_MAINTENANCE"
#EdgeSight Agent version
$EdgeSightAgentRef = "5.4.9.10"
#HotFixes XenApp 
#To searche  HotFix, add the hotfix in the $Ctx_HotFixXA6 or $Ctx_HotFixXA65
$Ctx_HotFixXA60 = "XA600W2K8R2X64R01"
$Ctx_HotFixXA65 = "XA650W2K8R2X64R03"
#Load value
$SrvLoad_Value = "9998"
#UPM variables
$UPMVer="5.0.0.111"
$UPMkey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\"
$valueDis = "DisplayName"
$valueVer = "DisplayVersion"
$valueInstDate="InstallDate"
#WMI TCP Port
$TcpPort="135"

if ($farm.ServerVersion -match "6.5") {$Ctx_HotFixs=$Ctx_HotFixXA65} else {$Ctx_HotFixs=$Ctx_HotFixXA60}

#  this code will test if this dll is loaded allready and else load it
if (-not ([appdomain]::CurrentDomain.getassemblies() |? {$_.ManifestModule -like "system.serviceprocess"})) {[void][System.Reflection.Assembly]::LoadWithPartialName('system.serviceprocess')}

# Turn off Errors
#$ErrorActionPreference = "silentlycontinue"


#Create html report
$Path = Split-Path -Parent $MyInvocation.MyCommand.Path #Check directory script run
$Path = $Path + "\"
$FileName="XenApp_Check-" + $farm
$PathBackup=$Path + "Backup\"
$PathLog=$Path + "Log\"
if ((Test-Path -path $PathBackup) -ne $True) {New-Item $PathBackup -type directory}
if ((Test-Path -path $PathLog) -ne $True) {New-Item $PathLog -type directory}


#File functions
. $Path"Ctx_FunctionsXA6.ps1"

# Set the SMTP Server address
$SMTPSRV = "Your SMTP"
# Set the Email address to recieve from
$EmailFrom = "XenAppcheck@ctxblog.fr"
# Set the Email address to send the email to
$EmailTo = "Your email"


#-----------------------
#Variables XenApp_Check
#-----------------------

#Zone(s) variable
$scriptStartTime = get-date
$Zones = GET-XAZone | sort ZoneName
$Zones_Count = (($Zones | Measure-Object).Count)
$OnlineServer = (($Zones| Get-XAServer -OnlineOnly | Sort-Object ServerName))
$ExecutionTimeXaZone= GetElapsedTime
Write-host "GET-XAZone done"

#WorkerGroupe variable
$scriptStartTime = get-date
$WorkGpt = GET-XAWorkerGroup | sort WorkerGroupName
$WorkGpt_Count = (($WorkGpt | Measure-Object).Count)
$ExecutionTimeXaWorkGpt= GetElapsedTime
Write-host "GET-XAWorkerGroup done"

#LoaEvaluator variables
$scriptStartTime = get-date
$LoadEvaluator = GET-XALoadEvaluator | sort LoadEvaluatorName
$LoadEvalutaror_Count = (($LoadEvaluator | Measure-Object).Count)
$ExecutionTimeXALE= GetElapsedTime
Write-host "GET-XALoadEvaluator"


#Policy computer/user variables
#if you use local gpo change "localfarmgpo" by "LocalGpo" 
#or if you use domain GPO change by example "New-PSDrive -Name Gpo1 -PSProvider CitrixGroupPolicy -Root \ -DomainGpo Site1GPO"
$scriptStartTime = get-date
$PolicyCompMode = "localfarmgpo:\Computer\*" 
$PolicyComp = get-item $PolicyCompMode | sort Priority
$PolicyComp_Count = (($PolicyComp | Measure-Object).Count)
$ExecutionTimePolicyComp= GetElapsedTime
Write-host "Computer Policy done"


#if you use local gpo change "localfarmgpo" by "LocalGpo" 
#or if you use domain GPO change by example "New-PSDrive -Name Gpo1 -PSProvider CitrixGroupPolicy -Root \ -DomainGpo Site1GPO"
$scriptStartTime = get-date
$PolicyUserMode = "localfarmgpo:\user\*"
$PolicyUser = get-item $PolicyUserMode | sort Priority
$PolicyUser_Count = (($PolicyUser | Measure-Object).Count)
$ExecutionTimePolicyUser= GetElapsedTime
Write-host "User Policy done"

#Administrator variable
$scriptStartTime = get-date
$Adm = Get-XAAdministrator
$Adm_Count = (($Adm | Measure-Object).Count)
$ExecutionTimeXAAdministrator= GetElapsedTime
Write-host "Get-XAAdministrator done"

#Applications variable
$scriptStartTime = get-date
$Applications = Get-XAApplicationReport *
$Applications_Count = (($Applications | Measure-Object).Count)
$ExecutionTimeXAApplicationReport= GetElapsedTime
Write-host "Get-XAApplicationReport * done"


#Server variable
$scriptStartTime = get-date
$Servers = Get-XAServer	| sort FolderPath 
$Servers_Count = (($Servers | Measure-Object).Count)
$AllServers = (($Servers | Select-Object ServerName | Sort-Object ServerName))
$ExecutionTimeXAServers= GetElapsedTime
Write-host "Get-XAServer done" `n


#Filter folder
$AppFolderExclude = "Folder1", "Folder2"
$AppNameExclude = "App1", "App2"
$ServFolderExclude = "Srv1", "Srv2"


#Check function (FALSE=Disable - TRUE=Enabled)
$Check_DisplaySection = "TRUE"
$Check_GeneralDetails = "TRUE"
$Check_DsCheckReport = "TRUE"
$Check_CmdletExecutionTime = "FALSE"
$Check_OutputEnteteZone = "TRUE"
$Check_OutputEntetePolicyCompDisable = "TRUE"
$Check_OutputEntetePolicyUserDisable = "TRUE"
$Check_VarFunctionEvent3999 = "TRUE"
$Check_VarOutputEnteteServ = "TRUE"
$Check_VarOutputServDisk = "TRUE"
$Check_VarOuTputServLogon = "TRUE"
$Check_VarOuTputLoadMaintenance = "TRUE"
$Check_VarFunctionApp_CountServer = "TRUE"
$Check_VarFunctionApp_Disable = "TRUE"
$Check_VarUptime = "TRUE"
$Check_VarTypeSrv = "TRUE"
$Check_EdgeSightAgentVer = "TRUE"
$Check_Ctx_HotFix = "TRUE"
$Check_Ctx_SrvLoad = "TRUE"
$Check_Ctx_UPMver = "TRUE"


#Farm Name
$XenAppReport += Get-CustomHTML "Farm Name : $Farm"
$XenAppReport += Get-CustomHeaderClose


$DsnPath = Get-Content "C:\Program Files (x86)\Citrix\Independent Management Architecture\mf20.dsn"
foreach ($str in $DsnPath) {$1=$str.contains("DRIVER") ; $2=$str.contains("SERVER") ; if($1 -eq $True) {$DataStoreFile = $Str} ElseIF ($2 -eq $True) {$DataStoreServer = $Str} }


# ---- General Summary Info ----
	#Write-CustomOut "..Adding General Summary Info to the report"
	$scriptStartTime = get-date
	$TimeGng =""
	$CommentsSet = $Comments
	$Comments = $False
	
	If ($Check_GeneralDetails -eq "TRUE")
	{
	$XenAppReport += Get-CustomHeader "General Details"
	$XenAppReport += Get-HTMLDetail "Domain :" ($Domain)
	$XenAppReport += Get-HTMLDetail "Farm version :" ($farm.ServerVersion)
	$XenAppReport += Get-HTMLDetail "Datastore type :" (@($DataStoreFile.Substring(7)))
	$XenAppReport += Get-HTMLDetail "Datastore Server :" (@($DataStoreServer.Substring(7)))
		
		Foreach ($PolicyCompGpo in $PolicyComp)
		{
		cd ("LocalFarmGpo:\computer\"+($PolicyCompGpo.Name)+"\settings\licensing")
		$LicSrv = get-itemproperty LicenseServerHostName
		$LicPort = get-itemproperty LicenseServerPort
		
			if (($LicSrv.state-eq "enabled") -or ($LicSrv.state -eq "UseDefault")) 
			{
			$XenAppReport += Get-HTMLDetail "Citrix Licence Server Name and port :" (@($LicSrv.Value + " ("+$LicPort.value+") - Policy Name : "+$PolicyCompGpo.Name))
			} 
			else 
			{}
		}
		c:
		
	#Find TS/RDS licence server on local server
	$HKLM = 2147483650
	$reg = [WMIClass] "\\.\root\default:StdRegProv"
	$key = "SOFTWARE\Policies\Microsoft\Windows NT\Terminal Services" 
	$value = "LicenseServers" 
	$RDSLicenceServer = $reg.GetStringValue($HKLM, $key, $value)
	$XenAppReport += Get-HTMLDetail "TS/RDS licence server :" (@($RDSLicenceServer.sValue))
	
		
	$XenAppReport += Get-HTMLDetail "Number of Server :" (@($Servers_Count))
	$XenAppReport += Get-HTMLDetail "Number of Applications :" (@($Applications_Count))
	$XenAppReport += Get-HTMLDetail "Number of Zones :" (@($Zones_Count))
	$XenAppReport += Get-HTMLDetail "Number of Worker Groups :" (@($WorkGpt_Count))
	$XenAppReport += Get-HTMLDetail "Number of Load Evaluators :" (@($LoadEvalutaror_Count))
	$XenAppReport += Get-HTMLDetail "Number of Policy Computer :" (@($PolicyComp_Count))
	$XenAppReport += Get-HTMLDetail "Number of Policy User :" (@($PolicyUser_Count))
	$XenAppReport += Get-HTMLDetail "Number of Administrators :" (@($Adm_Count))
	$XenAppReport += Get-CustomHeaderClose
	}
	
	If ($Check_DisplaySection -eq "TRUE")
	{
	$XenAppReport += Get-CustomHeader "Section statut"
	If ($Check_GeneralDetails -eq "FALSE") {$XenAppReport += Get-HTMLDetail "General Details :" ("Disable")}
	If ($Check_DsCheckReport -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Dscheck :" ("Disable")}
	If ($Check_CmdletExecutionTime -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Cmdlet execution time :" ("Disable")}
	If ($Check_OutputEntetePolicyCompDisable -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Zone :" ("Disable")}
	If ($Check_OutputEntetePolicyCompDisable -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Computer Policy :" ("Disable")}
	If ($Check_OutputEntetePolicyUserDisable -eq "FALSE") {$XenAppReport += Get-HTMLDetail "User Policy :" ("Disable")}
	If ($Check_VarOutputEnteteServ -eq "FALSE") {$XenAppReport += Get-HTMLDetail "3999 event (ZDC election) :" ("Disable")}
	If ($Check_VarOutputEnteteServ -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Service statut :" ("Disable")}
	If ($Check_VarOutputServDisk -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Disk space :" ("Disable")}
	If ($Check_VarOuTputServLogon -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Logon server :" ("Disable")}
	If ($Check_VarOuTputLoadMaintenance -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Server(s) in Load Evaluator :" ("Disable")}
	If ($Check_VarFunctionApp_CountServer -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Server in Application(s)" ("Disable")}
	If ($Check_VarUptime -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Uptime Server :" ("Disable")}
	If ($Check_VarTypeSrv -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Server(s) type :" ("Disable")}
	If ($Check_EdgeSightAgentVer -eq "FALSE") {$XenAppReport += Get-HTMLDetail "EdgeSight agent version :" ("Disable")}
	If ($Check_Ctx_HotFix -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Citrix Hotfix missing :" ("Disable")}
	If ($Check_Ctx_SrvLoad -eq "FALSE") {$XenAppReport += Get-HTMLDetail "Server(s) Load :" ("Disable")}
	If ($Check_Ctx_UPMver -eq "FALSE") {$XenAppReport += Get-HTMLDetail "UPM version" ("Disable")}
	$XenAppReport += Get-CustomHeaderClose	
	}
	
	#Write-CustomOut " DsCheck.Exe Adding result Dscheck to the report
	If ($Check_DsCheckReport -eq "TRUE")
	{
	$XenAppReport += Get-CustomHeader ("DsCheck Details  <BR> ")
	$DsCheckReport =  &'C:\Program Files (x86)\Citrix\system32\dscheck.exe'
	  
		Foreach ($line in $DsCheckReport)
		{
		if($line -eq "") {} else {$DscheckLine += $line+"<br>"}
		}
			
	$XenAppReport += $DscheckLine
	$XenAppReport += Get-CustomHeaderClose
	}
	
	
	#Write-CustomOut " Cmdlet execution time result to the report
	If ($Check_CmdletExecutionTime -eq "TRUE")
	{
	$FormatTime = "(hh:mm:ss)"
	$XenAppReport += Get-CustomHeader ("Cmdlet Execution Time")
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXaFarm | Select @{N="Cmdlet";E={"Get-XAFarm"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXaFarm.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXaZone | Select @{N="Cmdlet";E={"Get-XAZone"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXaZone.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXaWorkGpt | Select @{N="Cmdlet";E={"Get-XAWorkerGroup"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXaWorkGpt.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXaLE | Select @{N="Cmdlet";E={"Get-XALoadEvaluator"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXaLE.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimePolicyComp | Select @{N="Cmdlet";E={"get-item $PolicyCompMode"}}, @{N="Time execution $FormatTime";E={$ExecutionTimePolicyComp.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimePolicyUser | Select @{N="Cmdlet";E={"get-item $PolicyUserMode"}}, @{N="Time execution $FormatTime";E={$ExecutionTimePolicyUser.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXAAdministrator | Select @{N="Cmdlet";E={"Get-XAAdministrator"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXAAdministrator.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXAApplicationReport | Select @{N="Cmdlet";E={"Get-XAApplicationReport"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXAApplicationReport.retStr}})
	$OutputEnteteCmdletExecutionTime += @($ExecutionTimeXAServers | Select @{N="Cmdlet";E={"Get-XAServer"}}, @{N="Time execution $FormatTime";E={$ExecutionTimeXAServers.retStr}})
	$XenAppReport += Get-HTMLTable $OutputEnteteCmdletExecutionTime 
	$XenAppReport += Get-CustomHeaderClose
	}
	
	
	
	#Write-CustomOut "..Adding Zones Details Info to the report"
	If ($Check_OutputEnteteZone -eq "TRUE")
	{
	Foreach ($Zones in $Zones) {$OutputEnteteZone += @($Zones | Select @{N="Zone Name";E={if($Zones.ZoneName -eq $Null){"Error"}else{$Zones.ZoneName}}}, @{N="Zone Data Collector";E={if($Zones.DataCollector -eq $Null){"Error"}else{$Zones.DataCollector}}}) }
	$XenAppReport += Get-CustomHeader ("Zone(s) Details : "+($Zones_Count))
	$XenAppReport += Get-HTMLTable $OutputEnteteZone
	$XenAppReport += Get-CustomHeaderClose
	}


	#Write-CustomOut "..Adding policy Computer disabled to the report"
	If ($Check_OutputEntetePolicyCompDisable -eq "TRUE")
	{
		$OutputEntetePolicyCompDisable = @()
		Foreach ($PolicyCompLine in $PolicyComp)
		{
		$VarFunctionOutputEntetePolicyCompDisable = PolicyCompDisable
		$OutputEntetePolicyCompDisable += $VarFunctionOutputEntetePolicyCompDisable.PolicyCompDisableTab
		$PolicyCompDisableCount += $VarFunctionOutputEntetePolicyCompDisable.PolicyCompDisableCount 
		}
	
	$XenAppReport += Get-CustomHeader ("Policy(s) Computer Disable : " + $PolicyCompDisableCount)
	$XenAppReport += Get-HTMLTable $OutputEntetePolicyCompDisable
	$XenAppReport += Get-CustomHeaderClose
	}
	
	
	#Write-CustomOut "..Adding policy User disabled to the report"
	If ($Check_OutputEntetePolicyUserDisable -eq "TRUE")
	{
		$OutputEntetePolicyUserDisable = @()
		Foreach ($PolicyUserLine in $PolicyUser)
		{
		$VarFunctionOutputEntetePolicyUserDisable = PolicyUserDisable
		$OutputEntetePolicyUserDisable += $VarFunctionOutputEntetePolicyUserDisable.PolicyUserDisableTab
		$PolicyUserDisableCount += $VarFunctionOutputEntetePolicyUserDisable.PolicyUserDisableCount 
		}
	
	$XenAppReport += Get-CustomHeader ("Policy(s) User Disable : " + $PolicyUserDisableCount)
	$XenAppReport += Get-HTMLTable $OutputEntetePolicyUserDisable
	$XenAppReport += Get-CustomHeaderClose
	}
		
	#Write-CustomOut "..Adding Server Check Info to the report"
	$OutputEnteteEvent3999 = @()
	$OutputEnteteServ = @()
	$OutputServDisk = @()
	$OuTputServLogon = @()
	$OuTputLoadMaintenance = @()
	$OutputOffLineServer = @()
	$OfflineServer = @()
	
	#*********************************************************************************************
	#Checks Server(s)
	#*********************************************************************************************
	Write-host "Server(s) :"
	Foreach ($Server in $Servers) 
	{
			$ServFolder = $Server.FolderPath	
			if ($ServFolder | select-string -pattern $ServFolderExclude) {}
			Else
			{
				If($OnLineServer-match $Server.ServerName)
				{
				$oldpos = $host.ui.RawUI.CursorPosition ; write-Host $Server -ForegroundColor  yellow -nonewline
					
					#Check WMI
					$tcpobject = new-Object system.Net.Sockets.TcpClient 
					#Connect to remote machine's port               
					$connect = $tcpobject.BeginConnect($Server,$TcpPort,$null,$null) 
					#Configure a timeout before quitting - time in milliseconds 
					$wait = $connect.AsyncWaitHandle.WaitOne(1000,$false) 
						If (-Not $Wait) 
						{
						$CountPortErr++
						Write-host " ------- $server TCP Port $TcpPort is closed" -F yellow
						$WmiError = 1
						$WmiTcpError +=  @($Server | Select @{n="Server(s)";e={$Server}},@{n="TCP port $TcpPort";e={"Error"}})
						}
						Else 
						{
						$WmiError = 0
						$error.clear()
						$tcpobject.EndConnect($connect) | out-Null 
						If ($Error[0]) {Write-warning ("{0}" -f $error[0].Exception.Message)}
						}
						   					
					
					#If $Check_VarFunctionEvent3999 is TRUE, The Event3999 is enable
					If ($Check_VarFunctionEvent3999 -eq "TRUE") 
					{
					#call Event3999 function
					$VarFunctionEvent3999 = Event3999
					$OutputEnteteEvent3999 += $VarFunctionEvent3999.Event3999Tab
					$3999Count += $VarFunctionEvent3999.Event3999Count
					}

					
					#If $Check_VarOutputEnteteServ is TRUE, The VarOutputEnteteServ is enable
					If ($Check_VarOutputEnteteServ -eq "TRUE")
					{
					#call TestingService Function
					$VarOutputEnteteServ = TestingService
					$OutputEnteteServ += $VarOutputEnteteServ.TestingServiceTab
					$TestServiceCount += $VarOutputEnteteServ.TestingServiceCount
					}
				
				
					#If $Check_VarOutputServDisk is TRUE, The VarOutputServDisk is enable
					If ($Check_VarOutputServDisk -eq "TRUE")
					{
					#call DiskSpace Function
					$VarOutputServDisk = DiskSpace
					$OutputServDisk += $VarOutputServDisk.DiskSpaceTab
					$DiSpaceCount += $VarOutputServDisk.DiskSpaceCount
					}
				
				
					#If $Check_VarOuTputServLogon is TRUE, The VarOuTputServLogon is enable
					If ($Check_VarOuTputServLogon -eq "TRUE")
					{	
					#call LogonDisabled Function
					$VarOuTputServLogon = LogonDisabled
					$OuTputServLogon += $VarOuTputServLogon.LogonDisabledTab
					$LogDisabledCount += $VarOuTputServLogon.LogonDisabledCount
					}
				
					#If $Check_VarOuTputLoadMaintenance is TRUE, The VarOuTputLoadMaintenance is enable
					If ($Check_VarOuTputLoadMaintenance -eq "TRUE")
					{	
					#call LoadMaintenance Function
					$VarOuTputLoadMaintenance = LoadMaintenance
					$OuTputLoadMaintenance += $VarOuTputLoadMaintenance.LoadMaintenanceTab
					$LoMaintenanceCount += $VarOuTputLoadMaintenance.LoadMaintenanceCount
					}
					
					
					#If $Check_VarUptime is TRUE, The Check_VarUptime is enable
					If ($Check_VarUptime -eq "TRUE")
					{
					#call TestingService Function
					$VarUptime = Uptime
					$OutputUptime += $VarUptime.UptimeTab
					$UptimeCount += $VarUptime.UptimeCount
					}
				
					#If $Check_VarTypeSrv is TRUE, The Check_VarTypeSrv is enable
					If ($Check_VarTypeSrv -eq "TRUE")
					{
					#call Hypervisor_type
					$VarOutputHypervisortype = HypervisorType
					$HypervisorTypeCountPhysical += $VarOutputHypervisortype.PhysicalCount
					$HypervisorTypeCountVm += $VarOutputHypervisortype.VmCount
					$HypervisorTypeCountXen += $VarOutputHypervisortype.XenCount
					$HypervisorTypeCountHyperV += $VarOutputHypervisortype.HyperVCount
					$HypervisorTypeCountError += $VarOutputHypervisortype.ErrorCount
									
					
					$HypervisorTypeCountPhysicalPercent = "{0:n2}" -f (($HypervisorTypeCountPhysical) * 100 / ($Servers_Count))
					$HypervisorTypeCountVmPercent = "{0:n2}" -f(($HypervisorTypeCountVm) * 100 / ($Servers_Count))
					$HypervisorTypeCountXenPercent = "{0:n2}" -f (($HypervisorTypeCountXen) * 100 / ($Servers_Count))
					$HypervisorTypeCountHyperVPercent = "{0:n2}" -f (($HypervisorTypeCountHyperV) * 100 / ($Servers_Count))
					$HypervisorTypeCountErrorPercent = "{0:n2}" -f (($HypervisorTypeCountError) * 100 / ($Servers_Count))
					}
					
					
					#If $Check_EdgeSightAgentVer is TRUE, The Check_EdgeSightAgentVer is enable
					If ($Check_EdgeSightAgentVer -eq "TRUE")
					{
					#call EdgeSightVersion Function
					$VarOutputEgeSightVersion = EdgeSightVersion
					$OutputEgeSightVersion += $VarOutputEgeSightVersion.EdgeSightTab
					$EdgeSightCount += $VarOutputEgeSightVersion.EdgeSightCount
					}
					
					#If $Check_Ctx_HotFix is TRUE, The Check_Ctx_HotFix is enable
					If ($Check_Ctx_HotFix -eq "TRUE")
					{
					#call Check_Ctx_HotFix Function
					$CtxHotFix = Ctx_HotFix
					$OutputCtxHotFix += $CtxHotFix.Ctx_HotFixTab
					$CtxHotFixCount += $CtxHotFix.Ctx_HotFixCount
					}
					
					#If $Check_Ctx_SrvLoad is TRUE, The Check_Ctx_SrvLoad is enable
					If ($Check_Ctx_SrvLoad -eq "TRUE")
					{
						if ($VarOuTputLoadMaintenance.LoadMaintenanceName -notmatch $LoadEval_Check)
						{
						#call Check_Ctx_HotFix Function
						$CtxSrvLoad = Ctx_SrvLoad
						$OutputCtxSrvLoad += $CtxSrvLoad.Ctx_SrvLoadTab
						$CtxSrvLoadCount += $CtxSrvLoad.Ctx_SrvLoadCount
						}
					}
					
					$host.ui.RawUI.CursorPosition = $oldpos ; write-Host $Server -ForegroundColor green
					
					#If $Check_Ctx_UPMver is TRUE, The Check_Ctx_UPMver is enable
					If ($Check_Ctx_UPMver -eq "TRUE")
					{
						#call Check_Ctx_HotFix Function
						$CtxUPMVer = Ctx_UPMver
						$OutputCtxUPMVer += $CtxUPMVer.Ctx_UPMverTab
						$CtxUPMCount += $CtxUPMVer.Ctx_UPMCount
					}
					
					$host.ui.RawUI.CursorPosition = $oldpos ; write-Host $Server -ForegroundColor green 
					
					
				}
				else 
				{
				$OfflineServer += $Server.ServerName
				Write-host $Server.ServerName " Offline" -ForegroundColor red
				$OutputOffLineServer += @($Server | Select @{N="Server Name";E={$Server.ServerName}},@{N="Folder Path";E={$Server.FolderPath}}, @{N="Zone";E={$Server.ZoneName}}	) 
				$OutputOffLineServerCount += 1
				}
			}
	}
	
				#*****************
				#Build HTML report
				#*****************
				If ($Check_VarFunctionEvent3999 -eq "TRUE") 
				{
				$XenAppReport += Get-CustomHeader ("Event 3999 : " + $3999Count)
				$XenAppReport += Get-HTMLTable $OutputEnteteEvent3999
				$XenAppReport += Get-CustomHeaderClose
				}
		
				If ($Check_VarOutputEnteteServ -eq "TRUE")
				{
				$XenAppReport += Get-CustomHeader ("Error Service : " + $TestServiceCount)
				$XenAppReport += Get-HTMLTable $OutputEnteteServ
				$XenAppReport += Get-CustomHeaderClose
				}
	
				If ($Check_VarOutputServDisk -eq "TRUE")
				{
				$XenAppReport += Get-CustomHeader ("Disk Space <= $DiskMin Go : " + $DiSpaceCount)
				$XenAppReport += Get-HTMLTable $OutputServDisk
				$XenAppReport += Get-CustomHeaderClose
				}
	
				If ($Check_VarOuTputServLogon -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("Logon Server(s) Disabled : "+ $LogDisabledCount)
				$XenAppReport += Get-HTMLTable $OuTputServLogon
				$XenAppReport += Get-CustomHeaderClose
				}
	
				If ($Check_VarOuTputLoadMaintenance -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("Server(s) in Load Evaluator $LoadEval_Check : " + $LoMaintenanceCount)
				$XenAppReport += Get-HTMLTable $OuTputLoadMaintenance
				$XenAppReport += Get-CustomHeaderClose
				}
				
				If ($Check_VarUptime -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("Uptime Server =>$Uptime day(s) : "+ $UptimeCount)
				$XenAppReport += Get-HTMLTable $OutputUptime
				$XenAppReport += Get-CustomHeaderClose
				}
				
				If ($Check_VarTypeSrv -eq "TRUE")
				{
				$XenAppReport += Get-CustomHeader ("Server(s) type : " + $Hypervisor_typeCount)
				$VarOutputHypervisorTypeVm += @($Server | Select  @{N="Type";E={"Physical"}}, @{N="Number Server";E={$HypervisorTypeCountPhysical}}, @{N="%";E={$HypervisorTypeCountPhysicalPercent}})
				$VarOutputHypervisorTypeVm += @($Server | Select  @{N="Type";E={"VMware"}}, @{N="Number Server";E={$HypervisorTypeCountVm}}, @{N="%";E={$HypervisorTypeCountVmPercent}})
				$VarOutputHypervisorTypeVm += @($Server | Select  @{N="Type";E={"Xen"}}, @{N="Number Server";E={$HypervisorTypeCountXen}}, @{N="%";E={$HypervisorTypeCountXenPercent}})
				$VarOutputHypervisorTypeVm += @($Server | Select  @{N="Type";E={"Hyper-V"}}, @{N="Number Server";E={$HypervisorTypeCountHyperV}}, @{N="%";E={$HypervisorTypeCountHyperVPercent}})
				
				if ($HypervisorTypeCountError -ge 1)
				{
				$VarOutputHypervisorTypeVm += @($Server | Select  @{N="Type";E={"Error"}}, @{N="Number Server";E={$HypervisorTypeCountError}}, @{N="%";E={$HypervisorTypeCountErrorPercent}})
				}
				$XenAppReport += Get-HTMLTable $VarOutputHypervisorTypeVm
				$XenAppReport += Get-CustomHeaderClose
				}
				
				If ($Check_EdgeSightAgentVer -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("EdgeSight agent version not match $EdgeSightAgentRef : $EdgeSightCount")
				$XenAppReport += Get-HTMLTable $OutputEgeSightVersion
				$XenAppReport += Get-CustomHeaderClose
				}
				
				If ($Check_Ctx_HotFix -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("Citrix Hotfix missing : $CtxHotFixCount")
				$XenAppReport += Get-HTMLTable $OutputCtxHotFix
				$XenAppReport += Get-CustomHeaderClose
				}
				
				If ($Check_Ctx_SrvLoad -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("Server(s) Load  : $CtxSrvLoadCount")
				$XenAppReport += Get-HTMLTable $OutputCtxSrvLoad
				$XenAppReport += Get-CustomHeaderClose
				}
				
				If ($Check_Ctx_UPMver -eq "TRUE")
				{	
				$XenAppReport += Get-CustomHeader ("UPM version  not match $UPMver : $CtxUPMCount")
				$XenAppReport += Get-HTMLTable $OutputCtxUPMVer
				$XenAppReport += Get-CustomHeaderClose
				}
	
	$XenAppReport += Get-CustomHeader ("Server(s) Off line : " + $OutputOffLineServerCount)
	$XenAppReport += Get-HTMLTable $OutputOffLineServer
	$XenAppReport += Get-CustomHeaderClose
	
	

	#Write-CustomOut "..Adding Applications Check Info to the  report"
	$OuTputApp_Server = @()
	$OuTputApp_Disable = @()
	
	
		#*********************************************************************************************
		#Checks Application(s)
		#*********************************************************************************************
		Foreach ($ApplicationsLine in $Applications) 
		{
			
				$AppFolder = $Applications.FolderPath
				$AppName = $Applications.DisplayName
				if (($AppFolder | select-string -pattern $AppFolderExclude) -or ($AppName | select-string -pattern $AppNameExclude))  {}
				Else
				{
				
				#call App_CountServer function
					If ($Check_VarFunctionApp_CountServer -eq "TRUE")
					{
					$VarFunctionApp_CountServer = App_CountServer
					$OuTputApp_Server += $VarFunctionApp_CountServer.App_CountServerTab
					$AppCountServCount += $VarFunctionApp_CountServer.App_CountServerCount
					}
					
				#call App_Disable function
					If ($Check_VarFunctionApp_Disable -eq "TRUE")
					{
					$VarFunctionApp_Disable = App_Disable
					$OutputApp_Disable += $VarFunctionApp_Disable.App_DisableTab
					$AppDisabCount += $VarFunctionApp_Disable.App_DisableCount
					}
				}
	
		}
		
		
				If ($Check_VarFunctionApp_CountServer -eq "TRUE")
				{
				$XenAppReport += Get-CustomHeader ("Server in Application(s) <=1 server : " + $AppCountServCount )
				$XenAppReport += Get-HTMLTable $OuTputApp_Server 
				$XenAppReport += Get-CustomHeaderClose
				}
	
	
				If ($Check_VarFunctionApp_Disable -eq "TRUE")
				{
				$XenAppReport += Get-CustomHeader ("Application(s) Disable : " + $AppDisabCount)
				$XenAppReport += Get-HTMLTable $OuTputApp_Disable
				$XenAppReport += Get-CustomHeaderClose
				}
	
	
	# ---- Time to build ----
	$XenAppReport += Get-CustomHeader "Time to build"
	$executiontime = (get-date) - $date
	$XenAppReport += Get-HTMLDetail "Time in minute(s):" (@([math]::round($executiontime.TotalMinutes,2)))
	$XenAppReport += Get-CustomHeaderClose
	$XenAppReport += Get-CustomHeader0Close
	$XenAppReport += Get-CustomHTMLClose
	
	
	$Date = Get-Date -Format "yyyyMMddHH"
	$FileXenApp_Check = $PathLog + $FileName + ".htm"
	$FileXenApp_CheckBackup = $PathBackup + $FileName + "_" + $date + ".htm"

	
	$XenAppReport | out-file -encoding ASCII -filepath $FileXenApp_Check
	$XenAppReport | out-file -encoding ASCII -filepath $FileXenApp_CheckBackup
	
	
	#Write-CustomOut "..Sending Email"
	send-SMTPmail $EmailTo $EmailFrom "XenApp_Check $Farm" $SMTPSRV $XenAppReport
	
	write-Host "Time in minute(s):" (@([math]::round($executiontime.TotalMinutes,2)))